
#include "ComboSample.hpp"

SFCApplet::FactorySPP SFCApplet::Boot(AEECLSID id, SFXAnsiStringPtr license)
{
	*license = "heap://";

    return (id == AEECLSID_COMBOSAMPLE) ? (&ComboSample::Factory) : (null);
}

ComboSample::ComboSample(Void)
{
	// R{{bNX̐FύX邽߂ɃtH[JẌړ
	// ƎɊǗ悤ɂ܂B
	RegisterHandler(SFEVT_KEY, AVK_UP, AVK_DOWN, HANDLER_AFTER, HANDLER_FUNCTION(KeyHandler));

	SFXWideString item[] = {"item1", "item2"};

	_combo = new SFRComboboxControl(this, SFXRectangle(10, 10, 100, 20), item, lengthof(item));

	// R{{bNXł̃ANVLb`邽߂
	// nho^܂B
	_combo->RegisterHandler(SREVT_CONTROL, HANDLER_AFTER, HANDLER_FUNCTION(ComboHandler));

	_button = new SFRButtonControl(this, SFXRectangle(10, 40, 100, 20), "button");

	// ܂AR{{bNXɃtH[JX𓖂Ă
	// F𒲐܂B
	_combo->SetStatusFocus(TRUE);
	ModifyColor();

    return;
}

ComboSample::~ComboSample(Void)
{
    return;
}

SFCInvokerPtr ComboSample::Factory(Void)
{
	return ::new ComboSample();
}

HANDLER_IMPLEMENT_VOIDVOID(ComboSample, ComboHandler)
{
	_button->SetStatusFocus(true);

	// R{{bNXtH[JXÔ
	// F𒲐܂B
	ModifyColor();
	return;
}

HANDLER_IMPLEMENT_BOOLEVENT(ComboSample, KeyHandler, event)
{
	Bool result = TRUE;

	switch (event.GetP16()) {
		case AVK_UP:
			FocusPrevious();

			// R{{bNX̐F𒲐܂B
			ModifyColor();
			break;
		case AVK_DOWN:
			FocusNext();

			// R{{bNX̐F𒲐܂B
			ModifyColor();
			break;
		default:
			result = FALSE;
			break;
	}
	return(result);
}

Void ComboSample::ModifyColor(Void)
{
	if (GetFocus() == _combo) {
		_combo->SetColor(SFRComboboxControl::COLOR_BUTTON_BASE, SFXRGBColor(0xFF, 0xCC, 0xCC,0xFF));
		_combo->SetColor(SFRComboboxControl::COLOR_BUTTON_LIGHT, SFXRGBColor(0xFF, 0xEE, 0xEE,0xFF));
		_combo->SetColor(SFRComboboxControl::COLOR_BUTTON_SHADOW, SFXRGBColor(0xAA, 0x77, 0x77,0xFF));
	}
	else {
		_combo->SetColor(SFRComboboxControl::COLOR_BUTTON_BASE, SFXRGBColor(0xDD, 0xDD, 0xDD,0xFF));
		_combo->SetColor(SFRComboboxControl::COLOR_BUTTON_LIGHT, SFXRGBColor(0xFF, 0xFF, 0xFF,0xFF));
		_combo->SetColor(SFRComboboxControl::COLOR_BUTTON_SHADOW, SFXRGBColor(0x88, 0x88, 0x88,0xFF));
	}
	return;
}
