
#ifndef __COMBOSAMPLE_HPP
#define __COMBOSAMPLE_HPP

#include <SophiaFramework.hpp>
#include "ComboSample.bid"

SFMTYPEDEFCLASS(ComboSample)
class ComboSample : public SFRApplication
{
	SFMSEALCOPY(ComboSample)
private:
	SFRComboboxControlPtr _combo;
	SFRButtonControlPtr _button;

public:

    ComboSample(Void);
    virtual ~ComboSample(Void);
    static SFCInvokerPtr Factory(Void);

	HANDLER_DECLARE_VOIDVOID(ComboHandler)
	HANDLER_DECLARE_BOOLEVENT(KeyHandler)
	Void ModifyColor(Void);
};

#endif // __COMBOSAMPLE_HPP //
